##// END OF EJS Templates
Merge pull request #1 from drtyhlpr/master...
burnbabyburn -
r273:c4c87030e1e5 Fusion
parent child
Show More
@@ -1,83 +1,88
1 1 #
2 2 # Build and Setup U-Boot
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 # Fetch and build U-Boot bootloader
9 9 if [ "$ENABLE_UBOOT" = true ] ; then
10 10 # Install c/c++ build environment inside the chroot
11 11 chroot_install_cc
12 12
13 13 # Copy existing U-Boot sources into chroot directory
14 14 if [ -n "$UBOOTSRC_DIR" ] && [ -d "$UBOOTSRC_DIR" ] ; then
15 15 # Copy local U-Boot sources
16 16 cp -r "${UBOOTSRC_DIR}" "${R}/tmp"
17 17 else
18 18 # Create temporary directory for U-Boot sources
19 19 temp_dir=$(as_nobody mktemp -d)
20 20
21 21 # Fetch U-Boot sources
22 22 as_nobody git -C "${temp_dir}" clone "${UBOOT_URL}"
23 23
24 24 # Copy downloaded U-Boot sources
25 25 mv "${temp_dir}/u-boot" "${R}/tmp/"
26 26
27 27 # Set permissions of the U-Boot sources
28 28 chown -R root:root "${R}/tmp/u-boot"
29 29
30 30 # Remove temporary directory for U-Boot sources
31 31 rm -fr "${temp_dir}"
32 32 fi
33 33
34 34 # Build and install U-Boot inside chroot
35 35 chroot_exec make -j${KERNEL_THREADS} -C /tmp/u-boot/ ${UBOOT_CONFIG} all
36 36
37 37 # Copy compiled bootloader binary and set config.txt to load it
38 38 install_exec "${R}/tmp/u-boot/tools/mkimage" "${R}/usr/sbin/mkimage"
39 39 install_readonly "${R}/tmp/u-boot/u-boot.bin" "${BOOT_DIR}/u-boot.bin"
40 40 printf "\n# boot u-boot kernel\nkernel=u-boot.bin\n" >> "${BOOT_DIR}/config.txt"
41 41
42 42 # Install and setup U-Boot command file
43 43 install_readonly files/boot/uboot.mkimage "${BOOT_DIR}/uboot.mkimage"
44 44 printf "# Set the kernel boot command line\nsetenv bootargs \"earlyprintk ${CMDLINE}\"\n\n$(cat ${BOOT_DIR}/uboot.mkimage)" > "${BOOT_DIR}/uboot.mkimage"
45 45
46 46 if [ "$ENABLE_INITRAMFS" = true ] ; then
47 47 # Convert generated initramfs for U-Boot using mkimage
48 48 chroot_exec /usr/sbin/mkimage -A "${KERNEL_ARCH}" -T ramdisk -C none -n "initramfs-${KERNEL_VERSION}" -d "/boot/firmware/initramfs-${KERNEL_VERSION}" "/boot/firmware/initramfs-${KERNEL_VERSION}.uboot"
49 49
50 50 # Remove original initramfs file
51 51 rm -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}"
52 52
53 53 # Configure U-Boot to load generated initramfs
54 54 printf "# Set initramfs file\nsetenv initramfs initramfs-${KERNEL_VERSION}.uboot\n\n$(cat ${BOOT_DIR}/uboot.mkimage)" > "${BOOT_DIR}/uboot.mkimage"
55 55 printf "\nbootz \${kernel_addr_r} \${ramdisk_addr_r} \${fdt_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
56 56 else # ENABLE_INITRAMFS=false
57 57 # Remove initramfs from U-Boot mkfile
58 58 sed -i '/.*initramfs.*/d' "${BOOT_DIR}/uboot.mkimage"
59 59
60 60 if [ "$BUILD_KERNEL" = false ] ; then
61 61 # Remove dtbfile from U-Boot mkfile
62 62 sed -i '/.*dtbfile.*/d' "${BOOT_DIR}/uboot.mkimage"
63 63 printf "\nbootz \${kernel_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
64 64 else
65 65 printf "\nbootz \${kernel_addr_r} - \${fdt_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
66 66 fi
67 67 fi
68 68
69 69 # Set mkfile to use the correct dtb file
70 70 sed -i "s/^\(setenv dtbfile \).*/\1${DTB_FILE}/" "${BOOT_DIR}/uboot.mkimage"
71 71
72 # Set mkfile to use the correct mach id
73 if [ "$ENABLE_QEMU" = true ] ; then
74 sed -i "s/^\(setenv machid \).*/\10x000008e0/" "${BOOT_DIR}/uboot.mkimage"
75 fi
76
72 77 # Set mkfile to use kernel image
73 78 sed -i "s/^\(fatload mmc 0:1 \${kernel_addr_r} \).*/\1${KERNEL_IMAGE}/" "${BOOT_DIR}/uboot.mkimage"
74 79
75 80 # Remove all leading blank lines
76 81 sed -i "/./,\$!d" "${BOOT_DIR}/uboot.mkimage"
77 82
78 83 # Generate U-Boot bootloader image
79 84 chroot_exec /usr/sbin/mkimage -A "${KERNEL_ARCH}" -O linux -T script -C none -a 0x00000000 -e 0x00000000 -n "RPi${RPI_MODEL}" -d /boot/firmware/uboot.mkimage /boot/firmware/boot.scr
80 85
81 86 # Remove U-Boot sources
82 87 rm -fr "${R}/tmp/u-boot"
83 88 fi
@@ -1,754 +1,774
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 20+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45
46 46 #bcm2708-rpi-0-w.dtb (Used for Pi 0 and PI 0W)
47 47 RPI0_DTB_FILE=${RPI0_DTB_FILE:=bcm2708-rpi-0-w.dtb}
48 48 RPI0_UBOOT_CONFIG=${RPI0_UBOOT_CONFIG:=rpi_defconfig}
49 49
50 50 #bcm2708-rpi-b.dtb (Used for Pi 1 model A and B)
51 51 RPI1_DTB_FILE=${RPI1_DTB_FILE:=bcm2708-rpi-b.dtb}
52 52 RPI1_UBOOT_CONFIG=${RPI1_UBOOT_CONFIG:=rpi_defconfig}
53 53
54 54 #bcm2708-rpi-b-plus.dtb (Used for Pi 1 model B+ and A+)
55 55 RPI1P_DTB_FILE=${RPI1P_DTB_FILE:=bcm2708-rpi-b-plus.dtb}
56 56 RPI1P_UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG:=rpi_defconfig}
57 57
58 58 #bcm2709-rpi-2-b.dtb (Used for Pi 2 model B)
59 59 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
60 60 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
61 61
62 62 #bcm2710-rpi-3-b.dtb (Used for Pi 3 model B)
63 63 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
64 64 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
65 65
66 66 #bcm2710-rpi-3-b-plus.dtb (Used for Pi 3 model B+)
67 67 RPI3P_DTB_FILE=${RPI3P_DTB_FILE:=bcm2710-rpi-3-b-plus.dtb}
68 68 RPI3P_UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG:=rpi_3_32b_defconfig}
69 69
70 70 # Debian release
71 71 RELEASE=${RELEASE:=jessie}
72 72 KERNEL_ARCH=${KERNEL_ARCH:=arm}
73 73 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
74 74 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
75 75 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
76 76 if [ "$KERNEL_ARCH" = "arm64" ] ; then
77 77 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
78 78 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
79 79 fi
80 80
81 81 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
82 82 #RASPBERRY PI 1, PI ZERO, PI ZERO W, AND COMPUTE MODULE DEFAULT Kernel BUILD CONFIGURATION
83 83 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
84 84 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
85 85 else
86 86 #RASPBERRY PI 2, PI 3, PI 3+, AND COMPUTE MODULE 3 DEFAULT Kernel BUILD CONFIGURATION
87 87 #https://www.raspberrypi.org/documentation/linux/kernel/building.md
88 88 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
89 89 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
90 90 fi
91 91
92 92 if [ "$RELEASE_ARCH" = "arm64" ] ; then
93 93 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
94 94 else
95 95 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
96 96 fi
97 97 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
98 98
99 99 # URLs
100 100 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
101 101 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
102 102 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
103 103 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
104 104 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
105 105 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
106 106
107 107 # Build directories
108 108 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
109 109 BUILDDIR="${BASEDIR}/build"
110 110
111 111 # Prepare date string for default image file name
112 112 DATE="$(date +%Y-%m-%d)"
113 113 if [ -z "$KERNEL_BRANCH" ] ; then
114 114 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
115 115 else
116 116 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
117 117 fi
118 118
119 119 # Chroot directories
120 120 R="${BUILDDIR}/chroot"
121 121 ETC_DIR="${R}/etc"
122 122 LIB_DIR="${R}/lib"
123 123 BOOT_DIR="${R}/boot/firmware"
124 124 KERNEL_DIR="${R}/usr/src/linux"
125 125 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
126 126
127 127 # Firmware directory: Blank if download from github
128 128 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
129 129
130 130 # General settings
131 131 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
132 132 PASSWORD=${PASSWORD:=raspberry}
133 133 USER_PASSWORD=${USER_PASSWORD:=raspberry}
134 134 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
135 135 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
136 136 EXPANDROOT=${EXPANDROOT:=true}
137 137
138 138 # Keyboard settings
139 139 XKB_MODEL=${XKB_MODEL:=""}
140 140 XKB_LAYOUT=${XKB_LAYOUT:=""}
141 141 XKB_VARIANT=${XKB_VARIANT:=""}
142 142 XKB_OPTIONS=${XKB_OPTIONS:=""}
143 143
144 144 # Network settings (DHCP)
145 145 ENABLE_DHCP=${ENABLE_DHCP:=true}
146 146
147 147 # Network settings (static)
148 148 NET_ADDRESS=${NET_ADDRESS:=""}
149 149 NET_GATEWAY=${NET_GATEWAY:=""}
150 150 NET_DNS_1=${NET_DNS_1:=""}
151 151 NET_DNS_2=${NET_DNS_2:=""}
152 152 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
153 153 NET_NTP_1=${NET_NTP_1:=""}
154 154 NET_NTP_2=${NET_NTP_2:=""}
155 155
156 156 # APT settings
157 157 APT_PROXY=${APT_PROXY:=""}
158 158 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
159 159
160 160 # Feature settings
161 161 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
162 162 ENABLE_I2C=${ENABLE_I2C:=false}
163 163 ENABLE_SPI=${ENABLE_SPI:=false}
164 164 ENABLE_IPV6=${ENABLE_IPV6:=true}
165 165 ENABLE_SSHD=${ENABLE_SSHD:=true}
166 166 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
167 167 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
168 168 ENABLE_SOUND=${ENABLE_SOUND:=true}
169 169 ENABLE_DBUS=${ENABLE_DBUS:=true}
170 170 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
171 171 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
172 172 ENABLE_XORG=${ENABLE_XORG:=false}
173 173 ENABLE_WM=${ENABLE_WM:=""}
174 174 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
175 175 ENABLE_USER=${ENABLE_USER:=true}
176 176 USER_NAME=${USER_NAME:="pi"}
177 177 ENABLE_ROOT=${ENABLE_ROOT:=false}
178 178 ENABLE_QEMU=${ENABLE_QEMU:=false}
179 179
180 180 # SSH settings
181 181 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
182 182 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
183 183 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
184 184 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
185 185 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
186 186
187 187 # Advanced settings
188 188 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
189 189 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
190 190 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
191 191 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
192 192 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
193 193 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
194 194 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
195 195 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
196 196 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
197 197 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
198 198 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
199 199 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
200 200
201 201 # Kernel compilation settings
202 202 BUILD_KERNEL=${BUILD_KERNEL:=false}
203 203 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
204 204 KERNEL_THREADS=${KERNEL_THREADS:=1}
205 205 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
206 206 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
207 207 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
208 208 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
209 209 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
210 210
211 211 if [ "$KERNEL_ARCH" = "arm64" ] ; then
212 212 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
213 213 else
214 214 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
215 215 fi
216 216
217 217 # Kernel compilation from source directory settings
218 218 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
219 219 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
220 220 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
221 221 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
222 222
223 223 # Reduce disk usage settings
224 224 REDUCE_APT=${REDUCE_APT:=true}
225 225 REDUCE_DOC=${REDUCE_DOC:=true}
226 226 REDUCE_MAN=${REDUCE_MAN:=true}
227 227 REDUCE_VIM=${REDUCE_VIM:=false}
228 228 REDUCE_BASH=${REDUCE_BASH:=false}
229 229 REDUCE_HWDB=${REDUCE_HWDB:=true}
230 230 REDUCE_SSHD=${REDUCE_SSHD:=true}
231 231 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
232 232
233 233 # Encrypted filesystem settings
234 234 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
235 235 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
236 236 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
237 237 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
238 238 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
239 239
240 240 # Chroot scripts directory
241 241 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
242 242
243 243 # Packages required in the chroot build environment
244 244 APT_INCLUDES=${APT_INCLUDES:=""}
245 245 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
246 246
247 247 # Packages required for bootstrapping
248 248 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
249 249 MISSING_PACKAGES=""
250 250
251 251 # Packages installed for c/c++ build environment in chroot (keep empty)
252 252 COMPILER_PACKAGES=""
253 253
254 254 set +x
255 255
256 256 # Set Raspberry Pi model specific configuration
257 257 if [ "$RPI_MODEL" = 0 ] ; then
258 DTB_FILE=${RPI2_DTB_FILE}
259 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
258 DTB_FILE=${RPI0_DTB_FILE}
259 UBOOT_CONFIG=${RPI0_UBOOT_CONFIG}
260 260 elif [ "$RPI_MODEL" = 1 ] ; then
261 DTB_FILE=${RPI2_DTB_FILE}
262 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
261 DTB_FILE=${RPI1_DTB_FILE}
262 UBOOT_CONFIG=${RPI1_UBOOT_CONFIG}
263 263 elif [ "$RPI_MODEL" = 1P ] ; then
264 DTB_FILE=${RPI2_DTB_FILE}
265 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
264 DTB_FILE=${RPI1P_DTB_FILE}
265 UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG}
266 266 elif [ "$RPI_MODEL" = 2 ] ; then
267 267 DTB_FILE=${RPI2_DTB_FILE}
268 268 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
269 269 elif [ "$RPI_MODEL" = 3 ] ; then
270 270 DTB_FILE=${RPI3_DTB_FILE}
271 271 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
272 BUILD_KERNEL=true
273 272 elif [ "$RPI_MODEL" = 3P ] ; then
274 273 DTB_FILE=${RPI3P_DTB_FILE}
275 274 UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG}
276 BUILD_KERNEL=true
277 275 else
278 276 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
279 277 exit 1
280 278 fi
281 279
282 280 # Check if the internal wireless interface is supported by the RPi model
283 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" = 2 ]; then
281 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]); then
282
284 283 echo "error: The selected Raspberry Pi model has no internal wireless interface"
285 284 exit 1
286 285 fi
287 286
288 287 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
289 288 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
290 289 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
291 290 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
292 291 exit 1
293 292 fi
294 293 fi
295 294
296 295 # Build RPi2/3 Linux kernel if required by Debian release
297 296 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
298 297 BUILD_KERNEL=true
299 298 fi
300 299
301 300 # Add packages required for kernel cross compilation
302 301 if [ "$BUILD_KERNEL" = true ] ; then
303 302 if [ "$KERNEL_ARCH" = "arm" ] ; then
304 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
305 else
306 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
303 if [ "$RELEASE_ARCH" = "armel" ]; then
304 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
305 fi
306 if [ "$RELEASE_ARCH" = "armhf" ]; then
307 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
308 fi
309 if [ "$RELEASE_ARCH" = "arm64" ]; then
310 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
311 fi
307 312 fi
308 313 fi
309 314
310 315 # Add libncurses5 to enable kernel menuconfig
311 316 if [ "$KERNEL_MENUCONFIG" = true ] ; then
312 317 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
313 318 fi
314 319
315 320 # Add ccache compiler cache for (faster) kernel cross (re)compilation
316 321 if [ "$KERNEL_CCACHE" = true ] ; then
317 322 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
318 323 fi
319 324
320 325 # Add cryptsetup package to enable filesystem encryption
321 326 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
322 327 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
323 328 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
324 329
325 330 if [ -z "$CRYPTFS_PASSWORD" ] ; then
326 331 echo "error: no password defined (CRYPTFS_PASSWORD)!"
327 332 exit 1
328 333 fi
329 334 ENABLE_INITRAMFS=true
330 335 fi
331 336
332 337 # Add initramfs generation tools
333 338 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
334 339 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
335 340 fi
336 341
337 342 # Add device-tree-compiler required for building the U-Boot bootloader
338 343 if [ "$ENABLE_UBOOT" = true ] ; then
339 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler"
344 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
340 345 fi
341 346
342 347 # Check if root SSH (v2) public key file exists
343 348 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
344 349 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
345 350 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
346 351 exit 1
347 352 fi
348 353 fi
349 354
350 355 # Check if $USER_NAME SSH (v2) public key file exists
351 356 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
352 357 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
353 358 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
354 359 exit 1
355 360 fi
356 361 fi
357 362
358 363 # Check if all required packages are installed on the build system
359 364 for package in $REQUIRED_PACKAGES ; do
360 365 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
361 366 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
362 367 fi
363 368 done
364 369
365 370 # If there are missing packages ask confirmation for install, or exit
366 371 if [ -n "$MISSING_PACKAGES" ] ; then
367 372 echo "the following packages needed by this script are not installed:"
368 373 echo "$MISSING_PACKAGES"
369 374
370 375 echo -n "\ndo you want to install the missing packages right now? [y/n] "
371 376 read confirm
372 377 [ "$confirm" != "y" ] && exit 1
373 378
374 379 # Make sure all missing required packages are installed
375 380 apt-get -qq -y install ${MISSING_PACKAGES}
376 381 fi
377 382
378 383 # Check if ./bootstrap.d directory exists
379 384 if [ ! -d "./bootstrap.d/" ] ; then
380 385 echo "error: './bootstrap.d' required directory not found!"
381 386 exit 1
382 387 fi
383 388
384 389 # Check if ./files directory exists
385 390 if [ ! -d "./files/" ] ; then
386 391 echo "error: './files' required directory not found!"
387 392 exit 1
388 393 fi
389 394
390 395 # Check if specified KERNELSRC_DIR directory exists
391 396 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
392 397 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
393 398 exit 1
394 399 fi
395 400
396 401 # Check if specified UBOOTSRC_DIR directory exists
397 402 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
398 403 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
399 404 exit 1
400 405 fi
401 406
402 407 # Check if specified FBTURBOSRC_DIR directory exists
403 408 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
404 409 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
405 410 exit 1
406 411 fi
407 412
408 413 # Check if specified CHROOT_SCRIPTS directory exists
409 414 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
410 415 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
411 416 exit 1
412 417 fi
413 418
414 419 # Check if specified device mapping already exists (will be used by cryptsetup)
415 420 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
416 421 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
417 422 exit 1
418 423 fi
419 424
420 425 # Don't clobber an old build
421 426 if [ -e "$BUILDDIR" ] ; then
422 427 echo "error: directory ${BUILDDIR} already exists, not proceeding"
423 428 exit 1
424 429 fi
425 430
426 431 # Setup chroot directory
427 432 mkdir -p "${R}"
428 433
429 434 # Check if build directory has enough of free disk space >512MB
430 435 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
431 436 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
432 437 exit 1
433 438 fi
434 439
435 440 set -x
436 441
437 442 # Call "cleanup" function on various signals and errors
438 443 trap cleanup 0 1 2 3 6
439 444
440 445 # Add required packages for the minbase installation
441 446 if [ "$ENABLE_MINBASE" = true ] ; then
442 447 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
443 448 fi
444 449
445 450 # Add required locales packages
446 451 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
447 452 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
448 453 fi
449 454
450 455 # Add parted package, required to get partprobe utility
451 456 if [ "$EXPANDROOT" = true ] ; then
452 457 APT_INCLUDES="${APT_INCLUDES},parted"
453 458 fi
454 459
455 460 # Add dbus package, recommended if using systemd
456 461 if [ "$ENABLE_DBUS" = true ] ; then
457 462 APT_INCLUDES="${APT_INCLUDES},dbus"
458 463 fi
459 464
460 465 # Add iptables IPv4/IPv6 package
461 466 if [ "$ENABLE_IPTABLES" = true ] ; then
462 467 APT_INCLUDES="${APT_INCLUDES},iptables"
463 468 fi
464 469
465 470 # Add openssh server package
466 471 if [ "$ENABLE_SSHD" = true ] ; then
467 472 APT_INCLUDES="${APT_INCLUDES},openssh-server"
468 473 fi
469 474
470 475 # Add alsa-utils package
471 476 if [ "$ENABLE_SOUND" = true ] ; then
472 477 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
473 478 fi
474 479
475 480 # Add rng-tools package
476 481 if [ "$ENABLE_HWRANDOM" = true ] ; then
477 482 APT_INCLUDES="${APT_INCLUDES},rng-tools"
478 483 fi
479 484
480 485 # Add fbturbo video driver
481 486 if [ "$ENABLE_FBTURBO" = true ] ; then
482 487 # Enable xorg package dependencies
483 488 ENABLE_XORG=true
484 489 fi
485 490
486 491 # Add user defined window manager package
487 492 if [ -n "$ENABLE_WM" ] ; then
488 493 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
489 494
490 495 # Enable xorg package dependencies
491 496 ENABLE_XORG=true
492 497 fi
493 498
494 499 # Add xorg package
495 500 if [ "$ENABLE_XORG" = true ] ; then
496 501 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
497 502 fi
498 503
499 504 # Replace selected packages with smaller clones
500 505 if [ "$ENABLE_REDUCE" = true ] ; then
501 506 # Add levee package instead of vim-tiny
502 507 if [ "$REDUCE_VIM" = true ] ; then
503 508 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
504 509 fi
505 510
506 511 # Add dropbear package instead of openssh-server
507 512 if [ "$REDUCE_SSHD" = true ] ; then
508 513 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
509 514 fi
510 515 fi
511 516
512 517 if [ "$RELEASE" != "jessie" ] ; then
513 518 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
514 519 fi
515 520
516 521 # Configure kernel sources if no KERNELSRC_DIR
517 522 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
518 523 KERNELSRC_CONFIG=true
519 524 fi
520 525
521 526 # Configure reduced kernel
522 527 if [ "$KERNEL_REDUCE" = true ] ; then
523 528 KERNELSRC_CONFIG=false
524 529 fi
525 530
526 531 # Configure qemu compatible kernel
527 532 if [ "$ENABLE_QEMU" = true ] ; then
533 DTB_FILE=vexpress-v2p-ca15_a7.dtb
534 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
528 535 KERNEL_DEFCONFIG="vexpress_defconfig"
529 536 if [ "$KERNEL_MENUCONFIG" = false ] ; then
530 537 KERNEL_OLDDEFCONFIG=true
531 538 fi
532 539 fi
533 540
534 541 # Execute bootstrap scripts
535 542 for SCRIPT in bootstrap.d/*.sh; do
536 543 head -n 3 "$SCRIPT"
537 544 . "$SCRIPT"
538 545 done
539 546
540 547 ## Execute custom bootstrap scripts
541 548 if [ -d "custom.d" ] ; then
542 549 for SCRIPT in custom.d/*.sh; do
543 550 . "$SCRIPT"
544 551 done
545 552 fi
546 553
547 554 # Execute custom scripts inside the chroot
548 555 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
549 556 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
550 557 chroot_exec /bin/bash -x <<'EOF'
551 558 for SCRIPT in /chroot_scripts/* ; do
552 559 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
553 560 $SCRIPT
554 561 fi
555 562 done
556 563 EOF
557 564 rm -rf "${R}/chroot_scripts"
558 565 fi
559 566
560 567 # Remove c/c++ build environment from the chroot
561 568 chroot_remove_cc
562 569
563 570 # Remove apt-utils
564 571 if [ "$RELEASE" = "jessie" ] ; then
565 572 chroot_exec apt-get purge -qq -y --force-yes apt-utils
566 573 fi
567 574
568 575 # Generate required machine-id
569 576 MACHINE_ID=$(dbus-uuidgen)
570 577 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
571 578 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
572 579
573 580 # APT Cleanup
574 581 chroot_exec apt-get -y clean
575 582 chroot_exec apt-get -y autoclean
576 583 chroot_exec apt-get -y autoremove
577 584
578 585 # Unmount mounted filesystems
579 586 umount -l "${R}/proc"
580 587 umount -l "${R}/sys"
581 588
582 589 # Clean up directories
583 590 rm -rf "${R}/run/*"
584 591 rm -rf "${R}/tmp/*"
585 592
586 593 # Clean up files
587 594 rm -f "${ETC_DIR}/ssh/ssh_host_*"
588 595 rm -f "${ETC_DIR}/dropbear/dropbear_*"
589 596 rm -f "${ETC_DIR}/apt/sources.list.save"
590 597 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
591 598 rm -f "${ETC_DIR}/*-"
592 599 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
593 600 rm -f "${ETC_DIR}/resolv.conf"
594 601 rm -f "${R}/root/.bash_history"
595 602 rm -f "${R}/var/lib/urandom/random-seed"
596 603 rm -f "${R}/initrd.img"
597 604 rm -f "${R}/vmlinuz"
598 605 rm -f "${R}${QEMU_BINARY}"
599 606
600 607 if [ "$ENABLE_QEMU" = true ] ; then
601 608 # Setup QEMU directory
602 609 mkdir "${BASEDIR}/qemu"
603 610
604 611 # Copy kernel image to QEMU directory
605 612 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
606 613
607 614 # Copy kernel config to QEMU directory
608 615 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
609 616
610 617 # Copy kernel dtbs to QEMU directory
611 618 for dtb in "${BOOT_DIR}/"*.dtb ; do
612 619 if [ -f "${dtb}" ] ; then
613 620 install_readonly "${dtb}" "${BASEDIR}/qemu/"
614 621 fi
615 622 done
616 623
617 624 # Copy kernel overlays to QEMU directory
618 625 if [ -d "${BOOT_DIR}/overlays" ] ; then
619 626 # Setup overlays dtbs directory
620 627 mkdir "${BASEDIR}/qemu/overlays"
621 628
622 629 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
623 630 if [ -f "${dtb}" ] ; then
624 631 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
625 632 fi
626 633 done
627 634 fi
628 635
636 # Copy u-boot files to QEMU directory
637 if [ "$ENABLE_UBOOT" = true ] ; then
638 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
639 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
640 fi
641 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
642 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
643 fi
644 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
645 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
646 fi
647 fi
648
629 649 # Copy initramfs to QEMU directory
630 650 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
631 651 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
632 652 fi
633 653 fi
634 654
635 655 # Calculate size of the chroot directory in KB
636 656 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
637 657
638 658 # Calculate the amount of needed 512 Byte sectors
639 659 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
640 660 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
641 661 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
642 662
643 663 # The root partition is EXT4
644 664 # This means more space than the actual used space of the chroot is used.
645 665 # As overhead for journaling and reserved blocks 35% are added.
646 666 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
647 667
648 668 # Calculate required image size in 512 Byte sectors
649 669 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
650 670
651 671 # Prepare image file
652 672 if [ "$ENABLE_SPLITFS" = true ] ; then
653 673 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
654 674 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
655 675 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
656 676 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
657 677
658 678 # Write firmware/boot partition tables
659 679 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
660 680 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
661 681 EOM
662 682
663 683 # Write root partition table
664 684 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
665 685 ${TABLE_SECTORS},${ROOT_SECTORS},83
666 686 EOM
667 687
668 688 # Setup temporary loop devices
669 689 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
670 690 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
671 691 else # ENABLE_SPLITFS=false
672 692 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
673 693 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
674 694
675 695 # Write partition table
676 696 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
677 697 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
678 698 ${ROOT_OFFSET},${ROOT_SECTORS},83
679 699 EOM
680 700
681 701 # Setup temporary loop devices
682 702 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
683 703 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
684 704 fi
685 705
686 706 if [ "$ENABLE_CRYPTFS" = true ] ; then
687 707 # Create dummy ext4 fs
688 708 mkfs.ext4 "$ROOT_LOOP"
689 709
690 710 # Setup password keyfile
691 711 touch .password
692 712 chmod 600 .password
693 713 echo -n ${CRYPTFS_PASSWORD} > .password
694 714
695 715 # Initialize encrypted partition
696 716 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
697 717
698 718 # Open encrypted partition and setup mapping
699 719 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
700 720
701 721 # Secure delete password keyfile
702 722 shred -zu .password
703 723
704 724 # Update temporary loop device
705 725 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
706 726
707 727 # Wipe encrypted partition (encryption cipher is used for randomness)
708 728 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
709 729 fi
710 730
711 731 # Build filesystems
712 732 mkfs.vfat "$FRMW_LOOP"
713 733 mkfs.ext4 "$ROOT_LOOP"
714 734
715 735 # Mount the temporary loop devices
716 736 mkdir -p "$BUILDDIR/mount"
717 737 mount "$ROOT_LOOP" "$BUILDDIR/mount"
718 738
719 739 mkdir -p "$BUILDDIR/mount/boot/firmware"
720 740 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
721 741
722 742 # Copy all files from the chroot to the loop device mount point directory
723 743 rsync -a "${R}/" "$BUILDDIR/mount/"
724 744
725 745 # Unmount all temporary loop devices and mount points
726 746 cleanup
727 747
728 748 # Create block map file(s) of image(s)
729 749 if [ "$ENABLE_SPLITFS" = true ] ; then
730 750 # Create block map files for "bmaptool"
731 751 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
732 752 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
733 753
734 754 # Image was successfully created
735 755 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
736 756 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
737 757 else
738 758 # Create block map file for "bmaptool"
739 759 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
740 760
741 761 # Image was successfully created
742 762 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
743 763
744 764 # Create qemu qcow2 image
745 765 if [ "$ENABLE_QEMU" = true ] ; then
746 766 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
747 767 QEMU_SIZE=16G
748 768
749 769 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
750 770 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
751 771
752 772 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
753 773 fi
754 774 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant